
/**
Die Rasenfläche.

- author: Albert Weidemann
- version: 1.0
*/
class Rasen: Rechteck
{
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "grün")
        PositionSetzen(x: 0, y: 10)
        GrößeSetzen(breite: 600, höhe: 490)
    }
}

/**
Der Zaum als Hindernis.

- author: Albert Wiedemann
- version: 1.0
*/
class ZaunNord: Rechteck
{
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "braun")
        PositionSetzen(x: 0, y: 0)
        GrößeSetzen(breite: 600, höhe: 10)
    }
}

/**
Der Zaum als Hindernis.

- author: Albert Wiedemann
- version: 1.0
*/
class ZaunOst: Rechteck
{
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "braun")
        PositionSetzen(x: 590, y: 0)
        GrößeSetzen(breite: 10, höhe: 500)
    }
}

/**
Der Zaum als Hindernis.

- author: Albert Wiedemann
- version: 1.0
*/
class ZaunSüd: Rechteck
{
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "braun")
        PositionSetzen(x: 0, y: 490)
        GrößeSetzen(breite: 600, höhe: 10)
    }
}

/**
Der Zaum als Hindernis.

- author: Albert Wiedemann
- version: 1.0
*/
class ZaunWest: Rechteck
{
    override init()
    {
        super.init()
        FarbeSetzen(farbe: "braun")
        PositionSetzen(x: 0, y: 0)
        GrößeSetzen(breite: 10, höhe: 500)
    }
}

/**
Der Mähroboter geht gerade aus, bis er auf einen Zaun trifft (braunes Hindernis).

- author: Albert Wiedemann
- version: 1.0
*/
class Mähroboter: Figur
{
    var batteriestand: Int
    
    /**
    Der Konstruktor erzeugt die Form, den Zaun und die Rasenfläche
    */
    override init ()
    {
        batteriestand = 200
        super.init()
        FigurteilFestlegenRechteck(x: -50, y: -40, breite: 20, höhe: 10, farbe: "schwarz")
        FigurteilFestlegenRechteck(x: -50, y: 30, breite: 20, höhe: 10, farbe: "schwarz")
        FigurteilFestlegenRechteck(x: 30, y: -40, breite: 20, höhe: 10, farbe: "schwarz")
        FigurteilFestlegenRechteck(x: 30, y: 30, breite: 20, höhe: 10, farbe: "schwarz")
        FigurteilFestlegenEllipse(x: -50, y: -40, breite: 100, höhe: 80, farbe: "cyan")
        FigurteilFestlegenDreieck(x1: 5, y1: -10, x2: 45, y2: 0, x3: 5, y3: 10, farbe: "rot")
        
        PositionSetzen(x: 300, y: 400)
        Drehen(grad: 90)
        
        Rasen()
        ZaunNord()
        ZaunWest()
        ZaunOst()
        ZaunSüd()
        Blume()
        GanzNachVornBringen()
    }

    /**
    Mäht so lange, so lange kein Hindernis kommt.
    */
    func BisZaunMähen()
    {
        while !Berührt(farbe: "braun") && BatteriestandGeben()>10    //! bedeutet NICHT
        {
            FahrenUndMähen()
        }
    }

    /**
    Mäht so lange, so lange kein Hindernis kommt.
    */
    func Mähen()
    {
        while BatteriestandGeben() > 10
        {
            BisZaunMähen()
            Drehen(grad: 80)
            print(WinkelGeben())
            Gehen(länge: 10)
        }
    }

    /**
    Simulation des Mähvorgangs.
    */
    func FahrenUndMähen()
    {
        Gehen(länge: 5)
        MähspurDarstellen()
        BatteriestandUm1Reduzieren()
        print("Batteriestand \(BatteriestandGeben())")
    }

    /**
     Meldet den Batteriestand.
    - returns: Batteriestand
    */
    func BatteriestandGeben() -> Int
    {
        return batteriestand
    }
    
    /**
    Reduziert den Batteriestand um 1.
    */
    func BatteriestandUm1Reduzieren()
    {
        batteriestand = batteriestand - 1
    }

    /**
    Im Anzeigefenster eine Mähspur darstellen.
     */
    func MähspurDarstellen()
    {
        let r = Rechteck()
        r.FarbeSetzen(farbe: "hellgrün")
        if WinkelGeben()>45 && WinkelGeben()<=135
        {
            r.GrößeSetzen(breite: 20, höhe: 5)
            r.PositionSetzen(x: XPositionGeben()-10, y: YPositionGeben()+25)
        }
        if WinkelGeben()>135 && WinkelGeben()<=225
        {
            r.GrößeSetzen(breite: 5, höhe: 20)
            r.PositionSetzen(x: XPositionGeben()-25, y: YPositionGeben()-10)
        }
        if WinkelGeben()>225 && WinkelGeben()<=315
        {
            r.GrößeSetzen(breite: 20, höhe: 5)
            r.PositionSetzen(x: XPositionGeben()-10, y: YPositionGeben()-35)
        }
        if WinkelGeben()>315 || WinkelGeben()<=45
        {
            r.GrößeSetzen(breite: 5, höhe: 20)
            r.PositionSetzen(x: XPositionGeben()+25, y: YPositionGeben()-10)
        }

        GanzNachVornBringen ()
    }
}

/**
Stellt eine Blume im Rasen dar.

- author: Klaus Reinold
- version: 0.9
*/
class Blume: Figur
{

    /**
    Konstruktor für Objekte der Klasse Blume
    */
    override init()
    {
        super.init()
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        GrößeSetzen(größe: 3)
        PositionSetzen(x: 300, y: 300)
    }
    
    /**
    Wird bei jedem Schritt des Mähroboters automatisch ausgeführt
    */
    override func AktionAusführen()
    {
        //hier muss das Verschwinden der Blume bei Berührung durch den Mäher
        //(Farbe cyan) implementiert werden.
        
    }
}
let mähroboter = Mähroboter()
//mähroboter.Mähen()
