
/*:
## Aufgabe Weg aus dem Labyrinth
*/


/**
Eine horizontale Mauer

- author: Klaus Reinold
- version: 1.0
*/
class MauerHorizontal: Rechteck
{
//#-hidden-code
    /**
    Konstruktor
    - parameters:
    	- x: 0<=x<=15
        - y: 0<=y<=9
        - breite: x+breite <=15
    */
    init(x: Int, y: Int, breite: Int)
    {
        super.init()
        PositionSetzen(x: x*50+15-1,y: y*50+20-1)
        GrößeSetzen(breite: breite*50+2, höhe: 2)
        FarbeSetzen(farbe: "schwarz")
    }
//#-end-hidden-code
}

/**
Eine vertikale Mauer

- author: Klaus Reinold
- version: 1.0
*/
class MauerVertikal: Rechteck
{
//#-hidden-code
    /**
    Konstruktor
    - parameters:
    	- x: 0<=x<=15
        - y: 0<=y<=9
        - höhe: x+höhe <=9
    */
    init(x: Int, y: Int, höhe: Int)
    {
        super.init()
        PositionSetzen(x: x*50+15-1,y: y*50+20-1)
        GrößeSetzen(breite: 2, höhe: 2+höhe*50)
        FarbeSetzen(farbe: "schwarz")
    }
//#-end-hidden-code
}

/**
Der Ausgang

- author: Klaus Reinold
- version: 1.0
*/
class Ausgang: Rechteck
{
//#-hidden-code
    /**
    Konstruktor
    */
    override init()
    {
        super.init()
        PositionSetzen(x: 14*50+15+1,y: 8*50+20+1)
        GrößeSetzen(breite: 48, höhe: 48)
        FarbeSetzen(farbe: "grün")
    }
//#-end-hidden-code
}

/**
Klasse zur Beschreibung des Labyrinths

- author: Klaus Reinold
- version: 1.0
*/
class Labyrinth
{

    /**
    Legt die Mauern an und positioniert den Ausgang
    */
    init()
    {
        MauerHorizontal(x: 0,y: 0,breite: 15)
        MauerHorizontal(x: 3,y: 1,breite: 3)
        MauerHorizontal(x: 8,y: 1,breite: 3)
        MauerHorizontal(x: 13,y: 1,breite: 1)
        MauerHorizontal(x: 2,y: 2,breite: 4)
        MauerHorizontal(x: 12,y: 2,breite: 1)
        MauerHorizontal(x: 3,y: 3,breite: 3)
        MauerHorizontal(x: 11,y: 3,breite: 2)
        MauerHorizontal(x: 3,y: 4,breite: 2)
        MauerHorizontal(x: 12,y: 4,breite: 2)
        MauerHorizontal(x: 2,y: 5,breite: 4)
        MauerHorizontal(x: 8,y: 5,breite: 2)
        MauerHorizontal(x: 13,y: 5,breite: 2)
        MauerHorizontal(x: 1,y: 6,breite: 10)
        MauerHorizontal(x: 0,y: 7,breite: 10)
        MauerHorizontal(x: 1,y: 8,breite: 10)
        MauerHorizontal(x: 0,y: 9,breite: 15)
        
        MauerVertikal(x: 0,y: 0,höhe: 9)
        MauerVertikal(x: 1,y: 1,höhe: 5)
        MauerVertikal(x: 2,y: 0,höhe: 5)
        MauerVertikal(x: 3,y: 3,höhe: 1)
        MauerVertikal(x: 6,y: 1,höhe: 1)
        MauerVertikal(x: 6,y: 3,höhe: 2)
        MauerVertikal(x: 7,y: 0,höhe: 2)
        MauerVertikal(x: 7,y: 3,höhe: 3)
        MauerVertikal(x: 8,y: 1,höhe: 4)
        MauerVertikal(x: 9,y: 1,höhe: 3)
        MauerVertikal(x: 10,y: 2,höhe: 3)
        MauerVertikal(x: 11,y: 1,höhe: 7)
        MauerVertikal(x: 12,y: 0,höhe: 2)
        MauerVertikal(x: 12,y: 4,höhe: 5)
        MauerVertikal(x: 13,y: 2,höhe: 1)
        MauerVertikal(x: 13,y: 5,höhe: 3)
        MauerVertikal(x: 14,y: 1,höhe: 3)
        MauerVertikal(x: 14,y: 6,höhe: 3)
        MauerVertikal(x: 15,y: 0,höhe: 8)
        
        Ausgang()
    }
}

/**
Baut das gesamte Spiel auf.
 
- author: Klaus Reinold
- version: 1.0
*/
class Spiel
{
    init()
    {
        Labyrinth()
        Spielfigur()
    }
}


/**
Spielfigur

- author: Klaus Reinold
- version: 1.0
*/
class Spielfigur: Figur
{
    var delta: Int
    
    /**
    Legt die Form und die Startposition der Spielfigur fest
     */
    override init()
    {
        FigurteilFestlegenEllipse(x: -50, y: -50, breite: 100, höhe: 100, farbe: "rot")
        delta = 1
        PositionSetzen(x: 338,y: 143)
    }

    /*
    Hier die vier Methoden NachLinksBewegen(), NachRechtsBewegen(),
    NachUntenBewegen(), NachObenBewegen() ergänzen!
    Tipp 1: Lege erst die Methoden ohne Rumpf an, damit du von Anfang an
    Testen kannst!
    Tipp 2: Um die Turtle in eine bestimmte Richtung zu drehen, kannst du
    die Methode WinkelSetzen(winkel) nutzen (Ost: 0; Nord: 90, ...)
    */
    
    /**
    Wird aufgerufen, wenn eine Sondertaste gedrückt wurde
	- parameters:
		- taste: Nummer der Sondertaste
    */
    override func SonderTasteGedrückt(taste: Int)
    {
        switch(taste)
        {
            case 123: NachLinksBewegen()
            case 124: NachRechtsBewegen()
            case 125: NachUntenBewegen()
            case 126: NachObenBewegen()
            default: break
        }
    }
//#-editable-code

//#-end-editable-code
}

//#-editable-code
Spiel()
//#-end-editable-code
