/*:
## AufgabeD-Spielwelt (Teil 3): Blumenwelt
*/

/**
Die elementare Zelle der Blumenwelt

- author: Peter Brichzin
- version: 1.0
*/
class Zelle: Rechteck
{
//#-hidden-code

    /**
    Platziert eine Zelle
    */
    init (xLinksOben: Int, yLinksOben: Int, farbeNeu: String)
    {
        super.init()
        PositionSetzen(x: xLinksOben, y: yLinksOben)
        GrößeSetzen(breite: 46, höhe: 46)
        FarbeSetzen(farbe: farbeNeu)
    }
//#-end-hidden-code
}

/**
Blume, die darauf wartet gesammelt zu werden

- author: Peter Brichzin
- version: 1.0
 */
class Blume: Figur
{
    /**
    Der Konstruktor1 erzeugt eine Blume an der Pixel-Position (225/125).
	*/
    override init ()
    {
        super.init()
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "weiss")
        PositionSetzen(x: 225, y: 125)
        GanzNachVornBringen()
    }
    
    /**
    Der Konstruktor2 erzeugt eine Blume in einem Spielfeld mit 10x10 Zellen.
    an der Pixel-Position (225/125).
    - parameters:
        - xNeu:  x-Position der Blume
        - yNeu:  y-Position der Blume
   */
   init (xNeu: Int, yNeu: Int)
    {
        super.init();
        FigurteilFestlegenEllipse(x: 0, y: 0, breite: 25, höhe: 25, farbe: "gelb")
        FigurteilFestlegenEllipse(x: 0, y: -20, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 20, y: -10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 20, y: 10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: 0, y: 20, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -20, y: -10, breite: 20, höhe: 20, farbe: "weiss")
        FigurteilFestlegenEllipse(x: -20, y: 10, breite: 20, höhe: 20, farbe: "weiss")
        GanzNachVornBringen()
       
        if (xNeu<10) && (xNeu>=0) && (yNeu<10) && (yNeu>=0)
        {
            PositionSetzen(x: xNeu*50 + 25, y: yNeu*50 + 25)
        }
    }
}
/**
Die Spielfigur der Blumentwelt.

- author: Peter Brichzin
- version: Version 1.0
 */
class Florian: Figur
{
    /**
    Legt die Form und die Startposition fest.
    */
    override init()
    {
        super.init()
        FigurteilFestlegenRechteck(x: -20, y: -15, breite: 40, höhe: 60, farbe: "orange")
        FigurteilFestlegenEllipse(x: -10, y: -50, breite: 20, höhe: 30, farbe: "orange")
        FigurteilFestlegenDreieck(x1: 0, y1: 0, x2: 0, y2: 30, x3: 18, y3: 15, farbe: "gelb")
        PositionSetzen(x: 75, y: 125)
        GanzNachVornBringen()
    }

    /**
    Lässt Florian eine Zelle nach Osten gehen.
    */
    func NachOstenGehen()
    {
        PositionSetzen(x: XPositionGeben()+50, y: YPositionGeben())
    }

    /**
    Lässt Florian eine Zelle nach Westen gehen.
    */
    func NachWestenGehen()
    {
        PositionSetzen(x: XPositionGeben()-50, y: YPositionGeben())
    }

    /**
    Lässt Florian eine Zelle nach Süden gehen.
    */
    func NachSüdenGehen()
    {
        PositionSetzen(x: XPositionGeben(), y: YPositionGeben()+50)
    }

    /**
    Lässt Florian eine Zelle nach Norden gehen.
    */
    func NachNordenGehen()
    {
        PositionSetzen(x: XPositionGeben(), y: YPositionGeben()-50)
    }

    /**
    Dreht sich um 90 Grad nach links

    Tipp: Teste vorab (an einem Objekt der Klasse Florian)
    die Methoden Drehen, WinkelGeben, WinkelSetzen der Oberklasse
    */
    func LinksDrehen()
    {
        WinkelSetzen(winkel: WinkelGeben()+90)
    }

    /**
    Dreht sich um 90 Grad nach rechts
    */
    func RechtsDrehen()
    {
        WinkelSetzen(winkel: WinkelGeben()-90)
    }
}

/**
Legt die Blumenwelt an und die nicht beweglichen Objekte.\
Die Welt besteht aus 10x10 Zellen. Damit die Objekte der Klasse Zelle gut sichtbar sind, wird
zwischen den Zellen ein Abstand von 4 Pixeln gelassen. Mit diesem Rand hat die Welt Zellen der
Größe 50x 50 Pixel.
In der Blumenwelt sind auch mehrere Blumen.

- author: Peter Brichzin
- version: 12.12.19
 */
class Blumenwelt
{
//#-editable-code

    /**
    Baut das Szenario auf.
    */
    init()
    {
        // Diesen Abschnitt ignorieren, es werden die 10x10 Zellen der Welt erzeugt und positioniert
        for zellenNummerX in 0 ... 9
        {
            for zellenNummerY in 0 ... 9
            {

                Zelle(xLinksOben: 50*zellenNummerX+2, yLinksOben: 50*zellenNummerY+2, farbeNeu: "grün")  //: **Aufgabe c**
            }
        }
        // Abschnittsende

        var nummer: Int //ein Platzhalter für eine Nummer
        nummer = 2 //Startwert 2 für die Nummer
        
        while nummer < 7
        {
            Blume(xNeu: nummer, yNeu: 3)
            nummer = nummer + 1 // die Nummer wird um eins erhöht
        }
        
    }
//#-end-editable-code
}
//#-editable-code
Blumenwelt()
//#-end-editable-code
